Index: gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/FREETYPE.sh
===================================================================
--- gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/FREETYPE.sh	(revision 32250)
+++ gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/FREETYPE.sh	(revision 32251)
@@ -14,5 +14,5 @@
 
 opt_run_untar $force_untar $auto_untar $package $version
-opt_run_configure $force_config $auto_config $package $version "$prefix"
+opt_run_configure $force_config $auto_config $package $version "$prefix" --enable-static --disable-shared
 
 opt_run_make $compile   $package $version
Index: gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/LIBJPEG.sh
===================================================================
--- gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/LIBJPEG.sh	(revision 32250)
+++ gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/LIBJPEG.sh	(revision 32251)
@@ -42,6 +42,8 @@
 # http://www.linuxfromscratch.org/blfs/view/6.3/general/libjpeg.html
 # only the libjpeg.a is produced with this command
-opt_run_configure $force_config $auto_config $package $version "$prefix" \
-    --enable-static --enable-shared
+opt_run_configure $force_config $auto_config $package $version "$prefix"
+#opt_run_configure $force_config $auto_config $package $version "$prefix" \
+#    --enable-static --enable-shared
+#         --host=x86_64-linux-gnu --build=x86_64-linux-gnu --target=x86_64-linux-gnu --enable-static --enable-shared
 # The following didn't fix the configuration and subsequent libtool error described above
 # and with or without it, there's still reference to host=x86_64-unknown(-unknown)-linux-gnu in configure output:
Index: gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/LIBPNG.sh
===================================================================
--- gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/LIBPNG.sh	(revision 32250)
+++ gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/LIBPNG.sh	(revision 32251)
@@ -20,5 +20,5 @@
 opt_run_untar $force_untar $auto_untar $package $version
 
-opt_run_configure $force_config $auto_config $package $version $prefix
+opt_run_configure $force_config $auto_config $package $version $prefix --enable-static --disable-shared
 
 opt_run_make $compile $package $version
Index: gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/LIBTIFF.sh
===================================================================
--- gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/LIBTIFF.sh	(revision 32250)
+++ gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/LIBTIFF.sh	(revision 32251)
@@ -14,5 +14,5 @@
 
 opt_run_untar $force_untar $auto_untar $package $version 
-opt_run_configure $force_config $auto_config $package $version "$prefix"
+opt_run_configure $force_config $auto_config $package $version "$prefix" --enable-static --disable-shared
 
 opt_run_make $compile   $package $version
Index: gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/LIBZ.sh
===================================================================
--- gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/LIBZ.sh	(revision 32250)
+++ gs2-extensions/xpdf-tools/trunk/src/packages/CASCADE-MAKE/LIBZ.sh	(revision 32251)
@@ -30,9 +30,13 @@
 fi
 
+# We don't want the generated .so/.dylibs on linux and mac,  just the .a static libs
+# According to https://github.com/luvit/zlib/blob/master/configure
+# "Normally configure builds both a static and a shared library.
+# If you want to build just a static library, use: ./configure --static"
 if [ $force_config = "1" ] ; then
     echo "[pushd $package$version]"
     ( cd $package$version ; \
-      echo $CROSSCONFIGURE_VARS ./configure --prefix="$prefix" $CROSSCONFIGURE_ARGS $@ ; \
-      eval $CROSSCONFIGURE_VARS ./configure --prefix="$prefix" $CROSSCONFIGURE_ARGS $@ )
+      echo $CROSSCONFIGURE_VARS ./configure --static --prefix="$prefix" $CROSSCONFIGURE_ARGS $@ ; \
+      eval $CROSSCONFIGURE_VARS ./configure --static --prefix="$prefix" $CROSSCONFIGURE_ARGS $@ )
     if [ $? != 0 ] ; then
         echo "      Error encountered running *configure* stage of $progname"
Index: gs2-extensions/xpdf-tools/trunk/src/packages/GS-README.txt
===================================================================
--- gs2-extensions/xpdf-tools/trunk/src/packages/GS-README.txt	(revision 32250)
+++ gs2-extensions/xpdf-tools/trunk/src/packages/GS-README.txt	(revision 32251)
@@ -455,4 +455,18 @@
 
 https://unix.stackexchange.com/questions/279397/ldd-dont-find-path-how-to-add
+
+
+D. On why you can't build static binaries on Mac, but can build static libraries and link against them
+
+https://developer.apple.com/library/archive/qa/qa1118/_index.html (official page on how Mac doesn't support static binaries)
+https://stackoverflow.com/questions/3801011/ld-library-not-found-for-lcrt0-o-on-osx-10-6-with-gcc-clang-static-flag
+https://stackoverflow.com/questions/844819/how-to-static-link-on-os-x (mention of -Bstatic)
+https://www.allegro.cc/forums/thread/610923
+https://dropline.net/2015/10/static-linking-on-mac-os-x/ (explains that on Mac, .dylibs must be hidden for .a versions of libraries to be selected when linking)
+	This means that where possible we want to essentially do "--enable-static --disable-shared", or equivalent, when generating freetype, libz, libpng, libjpg, libtiff library files
+	so that Xpdf-Tools links against the .a files we generated rather than additional .dylib files 
+
+http://www.simplesystems.org/libtiff/build.html
+configuration options for building libtiff. Want to turn off the compile process for libtiff producing tiff binaries, but there appears to be no such option.
 
 