Index: main/trunk/greenstone2/bin/script/gsConvert.pl
===================================================================
--- main/trunk/greenstone2/bin/script/gsConvert.pl	(revision 32286)
+++ main/trunk/greenstone2/bin/script/gsConvert.pl	(revision 32287)
@@ -322,5 +322,5 @@
     $output_type =~ s/.*\-(.*)/$1/i;
     
-    print STDERR "@@@@@@@@ Using $pdf_tool for the conversion\n";
+    #print STDERR "@@@@@@@@ Using $pdf_tool for the conversion\n";
     
     # First determine which pdf conversion tool we're using among pdftohtml/pdfbox/xpdftools
Index: main/trunk/greenstone2/perllib/plugins/PDFv2Plugin.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/PDFv2Plugin.pm	(revision 32286)
+++ main/trunk/greenstone2/perllib/plugins/PDFv2Plugin.pm	(revision 32287)
@@ -35,9 +35,7 @@
 use Mojo::DOM; # for HTML parsing
 
-#use AutoLoadConverters;
 use PDFBoxConverter;
 use ConvertBinaryFile;
 
-#@PDFv2Plugin::ISA = ('ConvertBinaryFile', 'AutoLoadConverters', 'ReadTextFile');
 @PDFv2Plugin::ISA = ('ConvertBinaryFile', 'PDFBoxConverter', 'ReadTextFile');
 
@@ -123,14 +121,9 @@
     push(@$pluginlist, $class);
 
-#    push(@$inputargs,"-title_sub");
-#    push(@$inputargs,'^(Page\s+\d+)?(\s*1\s+)?');
-
     push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});
     push(@{$hashArgOptLists->{"OptList"}},$options);
 
-    #    my $auto_converter_self = new AutoLoadConverters($pluginlist,$inputargs,$hashArgOptLists,["PDFBoxConverter"],1);
     my $pdfbox_converter_self = new PDFBoxConverter($pluginlist, $inputargs, $hashArgOptLists);
     my $cbf_self = new ConvertBinaryFile($pluginlist, $inputargs, $hashArgOptLists);
-    #    my $self = BaseImporter::merge_inheritance($auto_converter_self, $cbf_self);
     my $self = BaseImporter::merge_inheritance($pdfbox_converter_self, $cbf_self);
     
@@ -167,28 +160,4 @@
 	}
     }
-
-    # if pdfbox_conversion is not on, check convert_to to make sure that xpdftools can
-    # support the selected output format, or fallback on a sensible default
-    # Not all available conversion output options are possible with xpdftools, as some are
-    # only handled by pdfbox. If a format is unavailable with xpdftools, default to pretty_html
-    # if (!$self->{"pdfbox_conversion"}) {
-    # 	my $convert_to = $self->{'convert_to'};
-    # 	my $fallback_convert_to = $convert_to;
-    # 	if($convert_to =~ /^html$/) {
-    # 	    $fallback_convert_to = "pretty_html";
-    # 	}
-    # 	elsif ($self->{'convert_to'} =~ /^pagedimg/) {
-    # 	    $fallback_convert_to = "paged_pretty_html";
-    # 	}
-    # 	elsif ($self->{'convert_to'} =~ /^paged_text$/) {
-    # 	    #	print STDERR "@@@ Conversion to " . $self->{'convert_to'} , " with Xpdf Tools is not yet implemented.\n";
-    # 	    $fallback_convert_to = "text";
-    # 	}
-
-    # 	if($convert_to =~ /^(html|pagedimg|paged_text)/) {
-    # 	    &gsprintf::gsprintf(STDERR, "{PDFv2Plugin.conversion_needs_pdfbox}\n", ($self->{'convert_to'}, $fallback_convert_to));
-    # 	    $self->{'convert_to'} = $fallback_convert_to;
-    # 	}
-    # }
     
     # set convert_to_plugin and convert_to_ext
@@ -203,8 +172,4 @@
     my $specific_options = $secondary_plugin_options->{$secondary_plugin_name};
 
-    # following title_sub removes "Page 1" added by pdftohtml, and a leading
-    # "1", which is often the page number at the top of the page. Bad Luck
-    # if your document title actually starts with "1 " - is there a better way?
-#    push(@$specific_options , "-title_sub", '^(Page\s+\d+)?(\s*1\s+)?');
     my $associate_tail_re = $self->{'associate_tail_re'};
     if ((defined $associate_tail_re) && ($associate_tail_re ne "")) {
@@ -267,5 +232,4 @@
     # ConvertBinaryFile init
     $self->SUPER::init(@_);
-#   $self->AutoLoadConverters::init(@_);
     $self->PDFBoxConverter::init(@_);
 
@@ -275,5 +239,4 @@
     my $self = shift (@_);
 
-#   $self->AutoLoadConverters::begin(@_);
     $self->PDFBoxConverter::begin(@_);
     $self->SUPER::begin(@_);
@@ -285,5 +248,4 @@
 
     $self->PDFBoxConverter::deinit(@_);
-#   $self->AutoLoadConverters::deinit(@_);
     $self->SUPER::deinit(@_);
 
@@ -318,7 +280,8 @@
     }
     
-    # for all other output formats, use pdfbox:    
-    #return $self->AutoLoadConverters::tmp_area_convert_file(@_);
-    # Here, we now do what AutoLoadConverters::tmp_area_convert_file(@_) does:
+    # for all other output formats, use pdfbox:
+    
+    # Here, we now do directly what AutoLoadConverters::tmp_area_convert_file(@_)
+    # does with PDFBoxConverter:
     my ($result, $result_str, $new_filename) = $self->PDFBoxConverter::convert($input_filename, $output_ext);
     if (defined $result && $result != 0) {
@@ -382,5 +345,5 @@
 	$self->xpdftohtml_convert_post_process($conv_filename);
     }
-    else { # use PDFPlugin's usual post processing
+    else { # use original PDFPlugin's usual post processing
 	$self->default_convert_post_process($conv_filename);
     }
@@ -689,5 +652,5 @@
 	
 	my $title = $sections[0];
-	$title =~ s/^\"?\w+\"?>//; # specific for pdftohtml...
+	$title =~ s/^\"?\w+\"?>//; # specific for old pdftohtml...
 	$title =~ s/<\/([^>]+)><\1>//g; # (eg) </b><b> - no space
 	$title =~ s/<[^>]*>/ /g;
@@ -696,6 +659,5 @@
 	$title =~ s/\s+$//;
 	$title =~ s/\s+/ /gs;
-	$title =~ s/^$self->{'title_sub'}// if ($self->{'title_sub'});
-	$title =~ s/^\s+//s; # in case title_sub introduced any...
+	$title =~ s/^\s+//s; # in case title_sub (of old PDFPlugin's old pdftohtml) introduced any... Generally still useful to remove spaces at the start?
 	$title = substr ($title, 0, 100);
 	$title =~ s/\s\S*$/.../;
Index: main/trunk/greenstone2/perllib/strings.properties
===================================================================
--- main/trunk/greenstone2/perllib/strings.properties	(revision 32286)
+++ main/trunk/greenstone2/perllib/strings.properties	(revision 32287)
@@ -1195,9 +1195,5 @@
 PDFv1Plugin.zoom:The factor by which to zoom the PDF for output. Only useful if -complex is set.
 
-PDFv2Plugin.zoom:The factor by which to zoom the PDF for (paged_)pretty_html output. Can be fractional.
-
-PDFv2Plugin.win_pdftotext_info:PDFv2Plugin uses Xpdf Tools to support pdf to text conversion, including on Windows.
-
-PDFv2Plugin.conversion_needs_pdfbox:*** Conversion to %s not supported with Xpdf Tools, defaulting to %s.\nTurn on pdfbox_conversion if you wish to enable output to the selected format.
+PDFv2Plugin.dpi:The resolution in DPI of background images generated for pagedimg(txt) and (paged_)pretty_html output settings.
 
 PostScriptPlugin.desc:This is a \"poor man's\" ps to text converter. If you are serious, consider using the PRESCRIPT package, which is available for download at http://www.nzdl.org/html/software.html