Index: /main/trunk/greenstone3/web/interfaces/default/js/berrybasket/berrybasket.js
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/js/berrybasket/berrybasket.js	(revision 32306)
+++ /main/trunk/greenstone3/web/interfaces/default/js/berrybasket/berrybasket.js	(revision 32307)
@@ -199,14 +199,12 @@
 		var berryElement = document.createElement('li');
 		list.appendChild(berryElement);
-		var title = berryItem.getAttribute('title');
-		var root_title = berryItem.getAttribute('root_title');
+		var title = berryItem.getAttribute('Title');
+		var root_title = berryItem.getAttribute('root_Title');
 		//var id = berryItem.getAttribute('collection')+":"+berryItem.getAttribute('name');
 
-		if (root_title != ""){
-			root_title +=":";
-		}
-
-		title = root_title+title;
-		title += " ("+berryItem.getAttribute('collection')+")";
+		if (root_title != null){
+		    title = root_title+":"+title;
+		}
+	        title += " ("+berryItem.getAttribute('collection')+")";
 		if (title.length > 76){
 			title = title.substring(0,30)+" ... "+title.substr(title.length-45,45);
@@ -351,11 +349,10 @@
 
 						if (id == tid){
-							var title = berryItem.getAttribute('title');
-							var root_title = berryItem.getAttribute('root_title');
-							if (root_title != ""){
-								root_title +=":";
+							var title = berryItem.getAttribute('Title');
+							var root_title = berryItem.getAttribute('root_Title');
+							if (root_title != null){
+							
+							    title = root_title+":"+title;
 							}
-
-							title = root_title+title;
 							if (title.length > 50){
 								title = title.substring(0,20)+" ... "+title.substr(title.length-35,35);
Index: /main/trunk/greenstone3/web/interfaces/default/js/berrybasket/berrycheckout.js
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/js/berrybasket/berrycheckout.js	(revision 32306)
+++ /main/trunk/greenstone3/web/interfaces/default/js/berrybasket/berrycheckout.js	(revision 32307)
@@ -4,4 +4,6 @@
 var source_link_collections = new Array(); // or add list of collections like ["pdfberry", "mgppdemo"];
 var document_link_collections = new Array(); // or add list of collections as above.
+//these are the default metadata items used by  berry baskets.
+var default_metas = ["Title", "root_Title", "root_assocfilepath", "root_srclinkFile", "name", "collection", "Date"];
 
 var docList = new Array();
@@ -153,15 +155,17 @@
 
 	        a.href=generateURL(doc);
-		a.appendChild(document.createTextNode(doc['title'])); 
-		if (doc['root_title'] != ""){
-			li.appendChild(document.createTextNode(doc['root_title']+": ")); 
+		a.appendChild(document.createTextNode(doc['Title'])); 
+		if (doc['root_Title']){
+			li.appendChild(document.createTextNode(doc['root_Title']+": ")); 
 		}
 		li.appendChild(a);
 		li.appendChild(document.createTextNode(" ("+doc['collection']+")"));
 		var metadata = "";
-		for (var metaItem in doc && metaItem != 'title'){
-			metadata = "\n"+metaItem+": "+ doc[metaItem]+"\n";
-		}
-		text +=metadata+"\n";
+	        for (var metaItem in doc) {
+		    if ( !default_metas.includes(metaItem)){
+		        metadata += " "+metaItem+": "+ doc[metaItem]+" ";
+		    }
+	        }
+		text +=metadata;
 		li.appendChild(document.createTextNode(text));
 		li.className = 'berrydoc';
@@ -169,20 +173,4 @@
 		new ygDDPlayer(img.id,'trash',docList);
 	}
-
-	/**
-	var extra = document.createElement('div');
-	var textview = document.createElement('span');
-	textview.id = 'extextview';
-	textview.className = 'extralink';
-	textview.appendChild(document.createTextNode("plain text version"));
-	var email = document.createElement('span');
-	email.appendChild(document.createTextNode("email to a friend"));
-	email.id = 'exemail';
-	email.className = 'extralink';
-	extra.appendChild(textview);
-	extra.appendChild(email);
-	content.appendChild(extra);
-	**/
-	//alert('x');
 
 }
@@ -387,5 +375,5 @@
 	// remove library
 	root_url = root_url.substring(0, root_url.lastIndexOf('/'));
-	url = root_url+"/sites/"+gs.xsltParams.site_name+"/collect/"+doc['collection']+"/index/assoc/"+doc["assocfilepath"]+"/"+doc["srclinkFile"];
+	url = root_url+"/sites/"+gs.xsltParams.site_name+"/collect/"+doc['collection']+"/index/assoc/"+doc["root_assocfilepath"]+"/"+doc["root_srclinkFile"];
     }
     return url;
@@ -408,5 +396,4 @@
 
 	var fulltext="";
-
 	for (var i in docList){
 	    var doc = docList[i];
@@ -414,9 +401,9 @@
 
 	    var metadata = "";
-	    if (doc['title']) {
-		metadata += gs.text.berry.doc_title+": "+doc['title']+"\n";
-	    }
-	    if (doc['root_title']) {
-		metadata += gs.text.berry.doc_root_title+": "+doc['root_title']+"\n";
+	    if (doc['Title']) {
+		metadata += gs.text.berry.doc_title+": "+doc['Title']+"\n";
+	    }
+	    if (doc['root_Title']) {
+		metadata += gs.text.berry.doc_root_title+": "+doc['root_Title']+"\n";
 
 	    }
@@ -427,8 +414,14 @@
 		metadata += gs.text.berry.doc_collection+": "+doc['collection']+"\n";
 	    }
-	    if (doc['date']) {
-		metadata += gs.text.berry.doc_date+": "+doc['date']+"\n";
-	    }
-		fulltext +=url+metadata+"\n";
+	    if (doc['Date']) {
+		metadata += gs.text.berry.doc_date+": "+doc['Date']+"\n";
+	    }
+	    // allow for inclusion of custom metadata
+	    for (var m in doc) {
+		if (!default_metas.includes(m)) {
+		    metadata += m +":" + doc[m]+"\n";
+		}
+	    }
+	    fulltext +=url+metadata+"\n";
 	}
 